# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import json

# Declaring global variables - Warnings: 1) WAPT context is only available in package functions; 2) Global variables are not persistent between calls


def update_package():
    result = False
    proxies = get_proxies()

    if not proxies:
        proxies = get_proxies_from_wapt_console()
     
    git_repo = "nomacs/nomacs"
    url_api = "https://api.github.com/repos/%s/releases" % git_repo   
    # Getting latest version information from official sources
    print(f"API used is: {url_api}")
    json_load = json.loads(wgets(url_api, proxies=proxies))

    # Initialize variables to store the latest version information
    latest_version = None
    url_dl = None
    filename = None

    # Vérifier que json_load est une liste
    if isinstance(json_load, list):
        # Itérer à travers chaque release
        for release in json_load:
            # Vérifier que la release contient une clé "assets" et que c'est une liste
            if "assets" in release and isinstance(release["assets"], list):
                for download in release["assets"]:
                    # Vérifier si l'URL de téléchargement se termine par .msi
                    if download["browser_download_url"].endswith(".msi"):
                        # Compare versions to find the latest one
                        current_version = release["tag_name"]
                        if latest_version is None or current_version > latest_version:
                            latest_version = current_version
                            url_dl = download["browser_download_url"]
                            filename = download["name"]
                        break  # Once we found a valid .msi in the assets, no need to check further in the same release

    if latest_version:
        if not isfile(filename):
            package_updated = True
            wget(url_dl, filename, proxies=proxies)

        # nettoyer les fichiers temporaires
        for f in glob.glob('*.msi'):
            if f != filename:
                remove_file(f)
        
        
        control.set_software_version(latest_version)
        control.save_control_to_wapt()
    